/*
 * This proprietary software may be used only as
 * authorised by a licensing agreement from ARM Limited
 * (C) COPYRIGHT 2007 - 2009 ARM Limited
 * ALL RIGHTS RESERVED
 * The entire notice above must be reproduced on all authorised
 * copies and copies may only be made to the extent permitted
 * by a licensing agreement from ARM Limited.
 */


#ifdef GL_ES
precision mediump float;
#endif


uniform mat4 WORLD;
uniform mat4 INV_TRANS_WORLD;
uniform mat4 VIEW_PROJECTION;
uniform vec3 cameraPosition;

uniform vec3 light0position;
uniform vec3 light1position;
uniform vec3 light2position;

attribute vec4 POSITION;
attribute vec2 TEXCOORD0;
attribute vec3 NORMAL;
attribute vec3 BINORMAL;
attribute vec3 TANGENT;

varying vec2 outTexcoord;

varying vec3 oPos;
varying vec3 tViewDir;

/* lights */
varying vec3 oLight0Dir;
varying vec3 tLight0Dir;
varying vec3 oLight1Dir;
varying vec3 tLight1Dir;

void main()
{
	oPos = (WORLD * POSITION).xyz;
	gl_Position = VIEW_PROJECTION * vec4(oPos, 1);
	
	outTexcoord.xy = TEXCOORD0 * vec2(1,-1);
		
	mat3 m = mat3(INV_TRANS_WORLD[0].xyz, INV_TRANS_WORLD[1].xyz, INV_TRANS_WORLD[2].xyz);
	mat3 tangentSpace = mat3(m * TANGENT, m * BINORMAL, m * NORMAL);
	
	vec3 oViewDir = oPos - cameraPosition;
	
	oLight0Dir = light0position - oPos;
	tLight0Dir = oLight0Dir * tangentSpace;
	
	oLight1Dir = light1position - oPos;
	tLight1Dir = oLight1Dir * tangentSpace;
	
	tViewDir = oViewDir * tangentSpace;
}
